// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: pkg/model/logblock.proto

package model

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on LogBlock with the rules defined in the
// proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *LogBlock) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on LogBlock with the rules defined in
// the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in LogBlockMultiError, or nil
// if none found.
func (m *LogBlock) ValidateAll() error {
	return m.validate(true)
}

func (m *LogBlock) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	// no validation rules for Index

	if utf8.RuneCountInString(m.GetLog()) < 1 {
		err := LogBlockValidationError{
			field:  "Log",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if _, ok := LogSeverity_name[int32(m.GetSeverity())]; !ok {
		err := LogBlockValidationError{
			field:  "Severity",
			reason: "value must be one of the defined enum values",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if m.GetCreatedAt() <= 0 {
		err := LogBlockValidationError{
			field:  "CreatedAt",
			reason: "value must be greater than 0",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return LogBlockMultiError(errors)
	}

	return nil
}

// LogBlockMultiError is an error wrapping multiple validation errors returned
// by LogBlock.ValidateAll() if the designated constraints aren't met.
type LogBlockMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m LogBlockMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m LogBlockMultiError) AllErrors() []error { return m }

// LogBlockValidationError is the validation error returned by
// LogBlock.Validate if the designated constraints aren't met.
type LogBlockValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e LogBlockValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e LogBlockValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e LogBlockValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e LogBlockValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e LogBlockValidationError) ErrorName() string { return "LogBlockValidationError" }

// Error satisfies the builtin error interface
func (e LogBlockValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sLogBlock.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = LogBlockValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = LogBlockValidationError{}
