// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: pkg/model/planpreview.proto

package model

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on PlanPreviewCommandResult with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *PlanPreviewCommandResult) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on PlanPreviewCommandResult with the
// rules defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// PlanPreviewCommandResultMultiError, or nil if none found.
func (m *PlanPreviewCommandResult) ValidateAll() error {
	return m.validate(true)
}

func (m *PlanPreviewCommandResult) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if utf8.RuneCountInString(m.GetCommandId()) < 1 {
		err := PlanPreviewCommandResultValidationError{
			field:  "CommandId",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetPipedId()) < 1 {
		err := PlanPreviewCommandResultValidationError{
			field:  "PipedId",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	// no validation rules for PipedUrl

	for idx, item := range m.GetResults() {
		_, _ = idx, item

		if all {
			switch v := interface{}(item).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, PlanPreviewCommandResultValidationError{
						field:  fmt.Sprintf("Results[%v]", idx),
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, PlanPreviewCommandResultValidationError{
						field:  fmt.Sprintf("Results[%v]", idx),
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return PlanPreviewCommandResultValidationError{
					field:  fmt.Sprintf("Results[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	// no validation rules for Error

	if len(errors) > 0 {
		return PlanPreviewCommandResultMultiError(errors)
	}

	return nil
}

// PlanPreviewCommandResultMultiError is an error wrapping multiple validation
// errors returned by PlanPreviewCommandResult.ValidateAll() if the designated
// constraints aren't met.
type PlanPreviewCommandResultMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m PlanPreviewCommandResultMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m PlanPreviewCommandResultMultiError) AllErrors() []error { return m }

// PlanPreviewCommandResultValidationError is the validation error returned by
// PlanPreviewCommandResult.Validate if the designated constraints aren't met.
type PlanPreviewCommandResultValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e PlanPreviewCommandResultValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e PlanPreviewCommandResultValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e PlanPreviewCommandResultValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e PlanPreviewCommandResultValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e PlanPreviewCommandResultValidationError) ErrorName() string {
	return "PlanPreviewCommandResultValidationError"
}

// Error satisfies the builtin error interface
func (e PlanPreviewCommandResultValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sPlanPreviewCommandResult.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = PlanPreviewCommandResultValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = PlanPreviewCommandResultValidationError{}

// Validate checks the field values on ApplicationPlanPreviewResult with the
// rules defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *ApplicationPlanPreviewResult) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on ApplicationPlanPreviewResult with the
// rules defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// ApplicationPlanPreviewResultMultiError, or nil if none found.
func (m *ApplicationPlanPreviewResult) ValidateAll() error {
	return m.validate(true)
}

func (m *ApplicationPlanPreviewResult) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if utf8.RuneCountInString(m.GetApplicationId()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "ApplicationId",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetApplicationName()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "ApplicationName",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	// no validation rules for ApplicationUrl

	if _, ok := ApplicationKind_name[int32(m.GetApplicationKind())]; !ok {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "ApplicationKind",
			reason: "value must be one of the defined enum values",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetApplicationDirectory()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "ApplicationDirectory",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetPipedId()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "PipedId",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetProjectId()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "ProjectId",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	// no validation rules for Labels

	if utf8.RuneCountInString(m.GetHeadBranch()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "HeadBranch",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if utf8.RuneCountInString(m.GetHeadCommit()) < 1 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "HeadCommit",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	// no validation rules for SyncStrategy

	// no validation rules for PlanSummary

	// no validation rules for PlanDetails

	// no validation rules for NoChange

	// no validation rules for Error

	if m.GetCreatedAt() <= 0 {
		err := ApplicationPlanPreviewResultValidationError{
			field:  "CreatedAt",
			reason: "value must be greater than 0",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return ApplicationPlanPreviewResultMultiError(errors)
	}

	return nil
}

// ApplicationPlanPreviewResultMultiError is an error wrapping multiple
// validation errors returned by ApplicationPlanPreviewResult.ValidateAll() if
// the designated constraints aren't met.
type ApplicationPlanPreviewResultMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m ApplicationPlanPreviewResultMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m ApplicationPlanPreviewResultMultiError) AllErrors() []error { return m }

// ApplicationPlanPreviewResultValidationError is the validation error returned
// by ApplicationPlanPreviewResult.Validate if the designated constraints
// aren't met.
type ApplicationPlanPreviewResultValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ApplicationPlanPreviewResultValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ApplicationPlanPreviewResultValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ApplicationPlanPreviewResultValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ApplicationPlanPreviewResultValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ApplicationPlanPreviewResultValidationError) ErrorName() string {
	return "ApplicationPlanPreviewResultValidationError"
}

// Error satisfies the builtin error interface
func (e ApplicationPlanPreviewResultValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sApplicationPlanPreviewResult.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ApplicationPlanPreviewResultValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ApplicationPlanPreviewResultValidationError{}
